Improvements for release process; a gensend hook.
[rsync.git] / runtests.sh
blob42cd866ec54d57f5278d323cf1ab9f40d304a5cd
1 #! /bin/sh
3 # Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
4 # Copyright (C) 2003, 2004, 2005, 2006 Wayne Davison
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License version
8 # 2 as published by the Free Software Foundation.
10 # This program is distributed in the hope that it will be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
13 # Lesser General Public License for more details.
15 # You should have received a copy of the GNU Lesser General Public
16 # License along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
19 # rsync top-level test script -- this invokes all the other more
20 # detailed tests in order. This script can either be called by `make
21 # check' or `make installcheck'. `check' runs against the copies of
22 # the program and other files in the build directory, and
23 # `installcheck' against the installed copy of the program.
25 # In either case we need to also be able to find the source directory,
26 # since we read test scripts and possibly other information from
27 # there.
29 # Whenever possible, informational messages are written to stdout and
30 # error messages to stderr. They're separated out by the build farm
31 # display scripts.
33 # According to the GNU autoconf manual, the only valid place to set up
34 # directory locations is through Make, since users are allowed to (try
35 # to) change their mind on the Make command line. So, Make has to
36 # pass in all the values we need.
38 # For other configured settings we read ./config.sh, which tells us
39 # about shell commands on this machine and similar things.
41 # rsync_bin gives the location of the rsync binary. This is either
42 # builddir/rsync if we're testing an uninstalled copy, or
43 # install_prefix/bin/rsync if we're testing an installed copy. On the
44 # build farm rsync will be installed, but into a scratch /usr.
46 # srcdir gives the location of the source tree, which lets us find the
47 # build scripts. At the moment we assume we are invoked from the
48 # source directory.
50 # This script must be invoked from the build directory.
52 # A scratch directory, 'testtmp', is used in the build directory to
53 # hold per-test subdirectories.
55 # This script also uses the $loglevel environment variable. 1 is the
56 # default value, and 10 the most verbose. You can set this from the
57 # Make command line. It's also set by the build farm to give more
58 # detail for failing builds.
61 # NOTES FOR TEST CASES:
63 # Each test case runs in its own shell.
65 # Exit codes from tests:
67 # 1 tests failed
68 # 2 error in starting tests
69 # 77 this test skipped (random value unlikely to happen by chance, same as
70 # automake)
72 # HOWEVER, the overall exit code to the farm is different: we return
73 # the *number of tests that failed*, so that it will show up nicely in
74 # the overall summary.
76 # rsync.fns contains some general setup functions and definitions.
79 # NOTES ON PORTABILITY:
81 # Both this script and the Makefile have to be pretty conservative
82 # about which Unix features they use.
84 # We cannot count on Make exporting variables to commands, unless
85 # they're explicitly given on the command line.
87 # Also, we can't count on 'cp -a' or 'mkdir -p', although they're
88 # pretty handy (see function makepath for the latter).
90 # I think some of the GNU documentation suggests that we shouldn't
91 # rely on shell functions. However, the Bash manual seems to say that
92 # they're in POSIX 1003.2, and since the build farm relies on them
93 # they're probably working on most machines we really care about.
95 # You cannot use "function foo {" syntax, but must instead say "foo()
96 # {", or it breaks on FreeBSD.
98 # BSD machines tend not to have "head" or "seq".
100 # You cannot do "export VAR=VALUE" all on one line; the export must be
101 # separate from the assignment. (SCO SysV)
103 # Don't rely on grep -q, as that doesn't work everywhere -- just redirect
104 # stdout to /dev/null to keep it quiet.
107 # STILL TO DO:
109 # We need a good protection against tests that hang indefinitely.
110 # Perhaps some combination of starting them in the background, wait,
111 # and kill?
113 # Perhaps we need a common way to cleanup tests. At the moment just
114 # clobbering the directory when we're done should be enough.
116 # If any of the targets fail, then (GNU?) Make returns 2, instead of
117 # the return code from the failing command. This is fine, but it
118 # means that the build farm just shows "2" for failed tests, not the
119 # number of tests that actually failed. For more details we might
120 # need to grovel through the log files to find a line saying how many
121 # failed.
124 set -e
126 . "./shconfig"
128 RUNSHFLAGS='-e'
129 export RUNSHFLAGS
131 # for Solaris
132 if [ -d /usr/xpg4/bin ]; then
133 PATH="/usr/xpg4/bin/:$PATH"
134 export PATH
137 if [ "x$loglevel" != x ] && [ "$loglevel" -gt 8 ]; then
138 if set -x; then
139 # If it doesn't work the first time, don't keep trying.
140 RUNSHFLAGS="$RUNSHFLAGS -x"
144 POSIXLY_CORRECT=1
145 if test x"$TOOLDIR" = x; then
146 TOOLDIR=`pwd`
148 srcdir=`dirname $0`
149 if test x"$srcdir" = x -o x"$srcdir" = x.; then
150 srcdir="$TOOLDIR"
152 if test x"$rsync_bin" = x; then
153 rsync_bin="$TOOLDIR/rsync"
156 # This allows the user to specify extra rsync options -- use carefully!
157 RSYNC="$rsync_bin $*"
158 #RSYNC="valgrind $rsync_bin $*"
160 TLS_ARGS=''
161 if egrep '^#define HAVE_LUTIMES 1' config.h >/dev/null; then
162 TLS_ARGS="$TLS_ARGS -l"
164 if egrep '#undef CHOWN_MODIFIES_SYMLINK' config.h >/dev/null; then
165 TLS_ARGS="$TLS_ARGS -L"
168 export POSIXLY_CORRECT TOOLDIR srcdir RSYNC TLS_ARGS
170 echo "============================================================"
171 echo "$0 running in $TOOLDIR"
172 echo " rsync_bin=$RSYNC"
173 echo " srcdir=$srcdir"
174 echo " TLS_ARGS=$TLS_ARGS"
176 if [ -f /usr/bin/whoami ]; then
177 testuser=`/usr/bin/whoami`
178 elif [ -f /usr/ucb/whoami ]; then
179 testuser=`/usr/ucb/whoami`
180 elif [ -f /bin/whoami ]; then
181 testuser=`/bin/whoami`
182 else
183 testuser=`id -un 2>/dev/null || echo ${LOGNAME:-${USERNAME:-${USER:-'UNKNOWN'}}}`
186 echo " testuser=$testuser"
187 echo " os=`uname -a`"
189 # It must be "yes", not just nonnull
190 if [ "x$preserve_scratch" = xyes ]; then
191 echo " preserve_scratch=yes"
192 else
193 echo " preserve_scratch=no"
196 # Check if setacl/setfacl is around and if it supports the -k or -s option.
197 if setacl -k u::7,g::5,o:5 testsuite 2>/dev/null; then
198 setfacl_nodef='setacl -k'
199 elif setfacl --help 2>&1 | grep ' -k,\|\[-[a-z]*k' >/dev/null; then
200 setfacl_nodef='setfacl -k'
201 elif setfacl -s u::7,g::5,o:5 testsuite 2>/dev/null; then
202 setfacl_nodef='setfacl -s u::7,g::5,o:5'
203 else
204 # The "true" command runs successfully, but does nothing.
205 setfacl_nodef=true
208 export setfacl_nodef
210 if [ ! -f "$rsync_bin" ]; then
211 echo "rsync_bin $rsync_bin is not a file" >&2
212 exit 2
215 if [ ! -d "$srcdir" ]; then
216 echo "srcdir $srcdir is not a directory" >&2
217 exit 2
220 skipped=0
221 missing=0
222 passed=0
223 failed=0
225 # Directory that holds the other test subdirs. We create separate dirs
226 # inside for each test case, so that they can be left behind in case of
227 # failure to aid investigation. We don't remove the testtmp subdir at
228 # the end so that it can be configured as a symlink to a filesystem that
229 # has ACLs and xattr support enabled (if desired).
230 scratchbase="$TOOLDIR"/testtmp
231 echo " scratchbase=$scratchbase"
232 [ -d "$scratchbase" ] || mkdir "$scratchbase"
234 suitedir="$srcdir/testsuite"
235 TESTRUN_TIMEOUT=300
237 export scratchdir suitedir TESTRUN_TIMEOUT
239 prep_scratch() {
240 [ -d "$scratchdir" ] && chmod -R u+rwX "$scratchdir" && rm -rf "$scratchdir"
241 mkdir "$scratchdir"
242 # Get rid of default ACLs and dir-setgid to avoid confusing some tests.
243 $setfacl_nodef "$scratchdir" || true
244 chmod g-s "$scratchdir"
245 case "$srcdir" in
246 /*) ln -s "$srcdir" "$scratchdir/src" ;;
247 *) ln -s "$TOOLDIR/$srcdir" "$scratchdir/src" ;;
248 esac
249 return 0
252 maybe_discard_scratch() {
253 [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
254 return 0
257 if [ "x$whichtests" = x ]; then
258 whichtests="*.test"
261 for testscript in $suitedir/$whichtests
263 testbase=`echo $testscript | sed -e 's!.*/!!' -e 's/.test\$//'`
264 scratchdir="$scratchbase/$testbase"
266 prep_scratch
268 case "$testscript" in
269 *hardlinks*) TESTRUN_TIMEOUT=600 ;;
270 *) TESTRUN_TIMEOUT=300 ;;
271 esac
273 set +e
274 "$TOOLDIR/"testrun $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
275 result=$?
276 set -e
278 if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
279 then
280 echo "----- $testbase log follows"
281 cat "$scratchdir/test.log"
282 echo "----- $testbase log ends"
283 if [ -f "$scratchdir/rsyncd.log" ]; then
284 echo "----- $testbase rsyncd.log follows"
285 cat "$scratchdir/rsyncd.log"
286 echo "----- $testbase rsyncd.log ends"
290 case $result in
292 echo "PASS $testbase"
293 passed=`expr $passed + 1`
294 maybe_discard_scratch
297 # backticks will fill the whole file onto one line, which is a feature
298 whyskipped=`cat "$scratchdir/whyskipped"`
299 echo "SKIP $testbase ($whyskipped)"
300 skipped=`expr $skipped + 1`
301 maybe_discard_scratch
304 # It failed, but we expected that. don't dump out error logs,
305 # because most users won't want to see them. But do leave
306 # the working directory around.
307 echo "XFAIL $testbase"
308 failed=`expr $failed + 1`
311 echo "FAIL $testbase"
312 failed=`expr $failed + 1`
313 if [ "x$nopersist" = xyes ]; then
314 exit 1
316 esac
317 done
319 echo '------------------------------------------------------------'
320 echo "----- overall results:"
321 echo " $passed passed"
322 [ "$failed" -gt 0 ] && echo " $failed failed"
323 [ "$skipped" -gt 0 ] && echo " $skipped skipped"
324 [ "$missing" -gt 0 ] && echo " $missing missing"
325 echo '------------------------------------------------------------'
327 # OK, so expr exits with 0 if the result is neither null nor zero; and
328 # 1 if the expression is null or zero. This is the opposite of what
329 # we want, and if we just call expr then this script will always fail,
330 # because -e is set.
332 result=`expr $failed + $missing || true`
333 echo "overall result is $result"
334 exit $result